// CResponseDlg.cpp : implementation file
//


#include "PDFReader/Source/Stdafx.h"
#include "PDFReader/Reader/PDFReader.h"
#include "PDFReader/Reader/ResponseDlg.h"

#include "afxdialogex.h"


// CResponseDlg dialog

IMPLEMENT_DYNAMIC(CResponseDlg, CDialogEx)

CResponseDlg::CResponseDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_DIALOG_RESPONSE, pParent)
  , m_szQuestion(_T(""))
  , m_szEdit(_T(""))
{

}

CResponseDlg::~CResponseDlg()
{
}

void CResponseDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialogEx::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_STATIC_LABEL, m_szQuestion);
  DDX_Text(pDX, IDC_EDIT_RESPONSE, m_szEdit);
  DDX_Control(pDX, IDC_EDIT_RESPONSE, m_editRes);
  DDX_Control(pDX, IDC_STATIC_LABEL, m_staticQuestion);
}


BEGIN_MESSAGE_MAP(CResponseDlg, CDialogEx)
  ON_BN_CLICKED(IDOK, &CResponseDlg::OnBnClickedOk)
  ON_BN_CLICKED(IDCANCEL, &CResponseDlg::OnBnClickedCancel)
END_MESSAGE_MAP()


// CResponseDlg message handlers


void CResponseDlg::OnBnClickedOk()
{
  // TODO: Add your control notification handler code here
  CDialogEx::OnOK();
}


void CResponseDlg::OnBnClickedCancel()
{
  // TODO: Add your control notification handler code here
  CDialogEx::OnCancel();
}

void CResponseDlg::SetTitle(CString szTitle)
{
  m_szTitle = szTitle;
}

void CResponseDlg::SetQuestion(CString szQuestion)
{
  m_szQuestion = szQuestion;
}

void CResponseDlg::SetDefault(CString szDefault)
{
  m_szDefault = szDefault;
}

void CResponseDlg::SetLabel(CString szLabel)
{
  m_szLabel = szLabel;
}

void CResponseDlg::SetIsPassword(BOOL bPassword)
{
  m_bIsPassword = bPassword;
}

foxit::WString CResponseDlg::GetResponse()
{
  if (m_szEdit.IsEmpty())
  {
    return L"";
  }
  USES_CONVERSION;
  WCHAR* pStr = new WCHAR[m_szEdit.GetLength()+1];
  wcscpy(pStr, CT2CW(m_szEdit));
  foxit::WString res = foxit::WString(pStr);
  delete pStr;
  return res;
}

BOOL CResponseDlg::OnInitDialog()
{
  CDialogEx::OnInitDialog();

  if (!m_szTitle.IsEmpty())
  {
    SetWindowText(m_szTitle);
  }

  if (m_szQuestion.IsEmpty())
  {
    m_staticQuestion.ShowWindow(SW_HIDE);
  }

  if (!m_szDefault.IsEmpty())
  {
    m_szEdit = m_szDefault;
  }

  if (m_bIsPassword)
  {
    m_editRes.SetPasswordChar(_T('*'));
  } 

  UpdateData(FALSE);

  return TRUE;  // return TRUE unless you set the focus to a control
                // EXCEPTION: OCX Property Pages should return FALSE
}
