#ifndef FS_PRINTMANAGER_H_
#define FS_PRINTMANAGER_H_

#define PRINTMANAGERDLL_API extern "C" __declspec(dllimport)

PRINTMANAGERDLL_API int FXPM_NewPrintManager();
PRINTMANAGERDLL_API int FXPM_GetPrintManagerErrorCode(int managerID);
PRINTMANAGERDLL_API int FXPM_InitPrintManager(int managerID, const char* sn, const char* key);
PRINTMANAGERDLL_API void FXPM_ReleasePrintManager(int managerID);
PRINTMANAGERDLL_API int FXPM_SetRenderMode(int managerID, int renderMode);

PRINTMANAGERDLL_API int FXPM_GetPrinterCount(int managerID);
PRINTMANAGERDLL_API const char* FXPM_GetPrinterName(int managerID, int printerIndex);
PRINTMANAGERDLL_API int FXPM_GetPaperSizeCount(int managerID, const char* printerName);
PRINTMANAGERDLL_API int FXPM_GetPaperSizeWidth(int managerID, const char* printerName, int paperIndex);
PRINTMANAGERDLL_API int FXPM_GetPaperSizeHeight(int managerID, const char* printerName, int paperIndex);
PRINTMANAGERDLL_API const char* FXPM_GetPaperSizeName(int managerID, const char* printerName, int paperIndex);
PRINTMANAGERDLL_API int FXPM_GetPaperSizeID(int managerID, const char* printerName, int paperIndex);
PRINTMANAGERDLL_API int FXPM_GetPaperSourceCount(int managerID, const char* printerName);
PRINTMANAGERDLL_API const char* FXPM_GetPaperSourceName(int managerID, const char* printerName, int sourceIndex);
PRINTMANAGERDLL_API int FXPM_GetPaperSourceID(int managerID, const char* printerName, int sourceIndex);
PRINTMANAGERDLL_API const char* FXPM_GetDefaultPrinterName(int managerID);
PRINTMANAGERDLL_API int FXPM_GetDefaultPaperSize(int managerID, const char* printerName);
PRINTMANAGERDLL_API int FXPM_GetDefaultPaperSource(int managerID, const char* printerName);

PRINTMANAGERDLL_API int FXPM_PrintPDFFromFile(int managerID, const char* pdfFileName, const char* pdfPassword);
PRINTMANAGERDLL_API int FXPM_PrintPDFFromMemory(int managerID, const unsigned char* pdfData, __int64 pdfDataLength, const char* pdfPassword);
PRINTMANAGERDLL_API int FXPM_PrintPDFFromFileToPrinter(int managerID, const char* pdfFileName, const char* pdfPassword, const char* printerName);
PRINTMANAGERDLL_API int FXPM_PrintPDFFromMemoryToPrinter(int managerID, const unsigned char* pdfData, __int64 pdfDataLength, const char* pdfPassword, const char* printerName);

PRINTMANAGERDLL_API int FXPM_NewPrintJob(int managerID);
PRINTMANAGERDLL_API int FXPM_AddPDFFromFileToJob(int managerID, int jobID, const char* pdfFileName, const char* pdfPassword);
PRINTMANAGERDLL_API int FXPM_AddPDFFromMemoryToJob(int managerID, int jobID, const unsigned char* pdfData, __int64 pdfDataLength, const char* pdfPassword);
PRINTMANAGERDLL_API int FXPM_BeginPrintJob(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_CancelPrintJob(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_GetPrintJobStatus(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_ClosePrintJob(int managerID, int jobID);

PRINTMANAGERDLL_API int FXPM_SetJobCopies(int managerID, int jobID, int newCopies);
PRINTMANAGERDLL_API int FXPM_SetJobColor(int managerID, int jobID, int newColorMode);
PRINTMANAGERDLL_API int FXPM_SetJobDuplex(int managerID, int jobID, int newDuplex);
PRINTMANAGERDLL_API int FXPM_SetJobRotation(int managerID, int jobID, int newRotation);
PRINTMANAGERDLL_API int FXPM_SetJobScaling(int managerID, int jobID, int newScaling);
PRINTMANAGERDLL_API int FXPM_SetJobCustomScale(int managerID, int jobID, double newCustomScalePercent);
PRINTMANAGERDLL_API int FXPM_SetJobPaperSource(int managerID, int jobID, int newPaperSourceID);
PRINTMANAGERDLL_API int FXPM_SetJobPaperSize(int managerID, int jobID, int newPaperSizeID);
PRINTMANAGERDLL_API int FXPM_SetJobPageList(int managerID, int jobID, int documentIndex, const char* pageList);
PRINTMANAGERDLL_API int FXPM_SetJobPriority(int managerID, int jobID, int newPriority);
PRINTMANAGERDLL_API int FXPM_SetJobQuality(int managerID, int jobID, int newQuality);
PRINTMANAGERDLL_API int FXPM_SetJobDocumentName(int managerID, int jobID, const char* newDocumentName);
PRINTMANAGERDLL_API int FXPM_SetJobCollate(int managerID, int jobID, int newCollate);
PRINTMANAGERDLL_API int FXPM_SetJobPrinter(int managerID, int jobID, const char* printerName);

PRINTMANAGERDLL_API int FXPM_GetJobCopies(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_GetJobColor(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_GetJobDuplex(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_GetJobRotation(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_GetJobScaling(int managerID, int jobID);
PRINTMANAGERDLL_API double FXPM_GetJobCustomScale(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_GetJobPaperSource(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_GetJobPaperSize(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_GetJobPageListCount(int managerID, int jobID, int documentIndex);
PRINTMANAGERDLL_API int FXPM_GetJobPageListItem(int managerID, int jobID, int documentIndex, int itemIndex);
PRINTMANAGERDLL_API int FXPM_GetJobPriority(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_GetJobQuality(int managerID, int jobID);
PRINTMANAGERDLL_API const char* FXPM_GetJobDocumentName(int managerID, int jobID);
PRINTMANAGERDLL_API int FXPM_GetJobCollate(int managerID, int jobID);
PRINTMANAGERDLL_API const char* FXPM_GetJobPrinter(int managerID, int jobID);

#endif  // FS_PRINTMANAGER_H_